// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{ffi, ChecksumKind};
use glib::{prelude::*, translate::*};

glib::wrapper! {
    #[doc(alias = "AsChecksum")]
    pub struct Checksum(Object<ffi::AsChecksum, ffi::AsChecksumClass>);

    match fn {
        type_ => || ffi::as_checksum_get_type(),
    }
}

impl Checksum {
    pub const NONE: Option<&'static Checksum> = None;

    #[doc(alias = "as_checksum_new")]
    pub fn new() -> Checksum {
        assert_initialized_main_thread!();
        unsafe { from_glib_full(ffi::as_checksum_new()) }
    }

    #[doc(alias = "as_checksum_new_with_value")]
    #[doc(alias = "new_with_value")]
    pub fn with_value(kind: ChecksumKind, value: &str) -> Checksum {
        assert_initialized_main_thread!();
        unsafe {
            from_glib_full(ffi::as_checksum_new_with_value(
                kind.into_glib(),
                value.to_glib_none().0,
            ))
        }
    }
}

impl Default for Checksum {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::Checksum>> Sealed for T {}
}

pub trait ChecksumExt: IsA<Checksum> + sealed::Sealed + 'static {
    #[doc(alias = "as_checksum_get_kind")]
    #[doc(alias = "get_kind")]
    fn kind(&self) -> ChecksumKind {
        unsafe { from_glib(ffi::as_checksum_get_kind(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "as_checksum_get_value")]
    #[doc(alias = "get_value")]
    fn value(&self) -> Option<glib::GString> {
        unsafe { from_glib_none(ffi::as_checksum_get_value(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "as_checksum_set_kind")]
    fn set_kind(&self, kind: ChecksumKind) {
        unsafe {
            ffi::as_checksum_set_kind(self.as_ref().to_glib_none().0, kind.into_glib());
        }
    }

    #[doc(alias = "as_checksum_set_value")]
    fn set_value(&self, value: &str) {
        unsafe {
            ffi::as_checksum_set_value(self.as_ref().to_glib_none().0, value.to_glib_none().0);
        }
    }
}

impl<O: IsA<Checksum>> ChecksumExt for O {}
